/*
 * lab1.c
 */

#include "lcd.h"

#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>


#define keyport PORTA           //Keypad Port
#define keyportddr DDRA         //Data Direction Register
#define keyportpin PINA         //Keypad Port Pins

#define COLUMN1 PA4				//Column1 PortC.0
#define COLUMN2 PA5			//Column2 PortC.1
#define COLUMN3 PA6				//Column3 PortC.2
#define COLUMN4 PA7			//Column4 PortC.3
#define ROW1 PA0				//Column1 PortC.7
#define ROW2 PA1				//Column2 PortC.6
#define ROW3 PA2				//Column3 PortC.5
#define ROW4 PA3				//Column4 PortC.4

#define NUMBER_COLUMNS 4
#define NUMBER_ROWS 4

#define TRUE 1
#define FALSE 0



void exemplu_lcd()
{
    LCD_print("Hello world!");

}

void task1_lcd()
{
    /* TODO task 1 LCD */

    // configurare porturi folosite
    DDRB &= ~((1 << PB0) | (1 << PB1));
    PORTB |= (1 << PB0) | (1 << PB1);

    // initializari
    char str[] = "Hello World";
    LCD_print(str);

    // main loop
    int8_t pos = 0;
    uint8_t PINB_old = 0xff;
    for(;;)
    {
        uint8_t PINB_crt = PINB;

        if((PINB_old & (1 << PB1)) && !(PINB_crt & (1 << PB1)))
        {
            pos += 1;
            if(pos + (sizeof(str) - 1) > 16)
                pos = 16 - (sizeof(str) - 1);

            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_printAt(pos, str);
        }
        
        if((PINB_old & (1 << PB0)) && !(PINB_crt & (1 << PB0)))
        {
            pos -= 1;
            if(pos < 0)
                pos = 0;

            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_printAt(pos, str);
        }

        PINB_old = PINB_crt;

        _delay_ms(5);
	}
}

void task2_lcd()
{
    /* TODO task 2 LCD */

    // main loop
    uint8_t pos = 0;
    for(;;)
    {
      //  LCD_putCharAt(pos++, USART0_receive());
        
        switch(pos)
        {
            case 0x10:
                pos = 0x40;
                break;
            case 0x50:
                pos = 0x00;
                break;
        }
    }
}

void bonus_lcd()
{
    /* TODO bonus LCD */

    // configurare porturi folosite
    DDRB &= ~((1 << PB0) | (1 << PB1));
    PORTB |= (1 << PB0) | (1 << PB1);

    // creare caracter custom
    uint8_t chuck[] = {0x00, 0x0e, 0x0e, 0x04, 0x0e, 0x04, 0x0e, 0xa};
    LCD_writeInstr(LCD_INSTR_CGRAM);
    for(uint8_t i = 0; i < sizeof(chuck); ++i)
        LCD_writeData(chuck[i]);
    LCD_writeInstr(LCD_INSTR_DDRAM);

    // main loop
    int8_t pos_old = 0x40;
    uint8_t PINB_old = 0xff;
    LCD_putCharAt(pos_old, 0);
    for(;;)
    {
        uint8_t PINB_crt = PINB;

        uint8_t pb0 = (PINB_old & (1 << PB0)) && !(PINB_crt & (1 << PB0));
        uint8_t pb1 = (PINB_old & (1 << PB1)) && !(PINB_crt & (1 << PB1));

        int8_t pos = pos_old;

        if(!(PINB_crt & (1 << PB0)) && !(PINB_crt & (1 << PB1)))
        {
            if(pos >= 0x40)
                pos -= 0x40;
        }
        else if(pb0)
        {
            pos -= 1;
            if(pos == 0x3f)
                pos = 0x40;
        }
        else if(pb1)
        {
            pos += 1;
            if(pos == 0x50)
                pos = 0x4f;
        }
        else
        {
            if(pos <= 0x1f)
                pos += 0x40;
        }

        if(pos != pos_old)
        {
            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_putCharAt(pos, 0);
            
            pos_old = pos;
        }

        PINB_old = PINB_crt;

        _delay_ms(5);
	}
}

int main()
{
    //LCD	
    LCD_init();

  //exemplu_lcd();
//  task1_lcd();
//  task2_lcd();
//  bonus_lcd();
	LCD_print("Buna, eu sunt");
	LCD_printAt(45,"Imparatul Zeu");
	_delay_ms(4000);
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_print("Misiunea ta este");
	LCD_printAt(45,"sa rezolvi dileme");
	//LCD_printAt(45, "Game :)");
	_delay_ms(4000);
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_print("Pick a mission");
	LCD_printAt(45,"1 2 3 4");
	//_delay_ms(4000);
	//LCD_writeInstr(LCD_INSTR_clearDisplay);
	

	 
	 
	 
	 
	
	DDRA=0xF0;
	
	PORTA=0x0F;
	
		while (1)
		{
		
			PORTA =0b11101111;
			if(!bit_is_set(PINA,0)){
				while(!bit_is_set(PINA,0));
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_print("Misiunea nr. 1");
				LCD_printAt(45,"Bomba din avion");
				_delay_ms(5000);
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_print("Esti in avion.");
				LCD_printAt(45,"Vezi o bomba,");
				_delay_ms(5000);
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_print("un sarpe mare,");
				LCD_printAt(45,"usa de la avion,");
				_delay_ms(5000);
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_print("ferestrele si o");
				LCD_printAt(45,"lopata.");
				_delay_ms(5000);
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_print("Ai cateva ");
				LCD_printAt(45,"secunde sa scapi");
				_delay_ms(5000);
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_print("de bomba.");
				LCD_printAt(45,"Alege:");
				_delay_ms(5000);
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_print("1) Deschide usa");
				LCD_printAt(45,"2) Ia lopata");
				_delay_ms(5000);
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_print("3) Loveste bomba");
				LCD_printAt(45,"4) Loveste sarpe");
				_delay_ms(5000);
				int cont=0;
					while(1){
						PORTA =0b11101111;
							if(!bit_is_set(PINA,0)){
								while(!bit_is_set(PINA,0));
								cont=1;
								break;
							}
						
						PORTA =0b11011111;
							if(!bit_is_set(PINA,0)){
								while(!bit_is_set(PINA,0));
								cont=2;
								break;
							}
							
						PORTA =0b10111111;
							if(!bit_is_set(PINA,0)){
								while(!bit_is_set(PINA,0));
								cont=3;
								break;
							}
							
						PORTA =0b11101111;
							if(!bit_is_set(PINA,1)){
								while(!bit_is_set(PINA,0));
								cont=4;
								break;
							}
					}
				if(cont==1){
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Ai fost tras");
					LCD_printAt(45,"prin usa");
					_delay_ms(5000);
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("GAME OVER");
					//LCD_printAt(45,"prin usa");
					_delay_ms(5000);
					break;
				}
				if(cont==2){
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Ai lopata in");
					LCD_printAt(45,"mana. Alege:");
					_delay_ms(5000);
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("1) Loveste usa");
					LCD_printAt(45,"cu lopata");
					_delay_ms(5000);
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("2) Loveste bomba");
					LCD_printAt(45,"cu lopata");
					_delay_ms(5000);
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("3) Casca-i gura");
					LCD_printAt(45,"sarpelui");
					_delay_ms(5000);
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("cu lopata");
					//LCD_printAt(45,"sarpelui");
					_delay_ms(5000);
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("4) Loveste");
					LCD_printAt(45,"geamurile");
					_delay_ms(5000);
					LCD_print("cu lopata");
					//LCD_printAt(45,"geamurile");
					_delay_ms(5000);
					
					cont=0;
					while(1){
						PORTA =0b11101111;
							if(!bit_is_set(PINA,0)){
								while(!bit_is_set(PINA,0));
								cont=1;
								break;
							}
						
						PORTA =0b11011111;
							if(!bit_is_set(PINA,0)){
								while(!bit_is_set(PINA,0));
								cont=2;
								break;
							}
							
						PORTA =0b10111111;
							if(!bit_is_set(PINA,0)){
								while(!bit_is_set(PINA,0));
								cont=3;
								break;
							}
							
						PORTA =0b11101111;
							if(!bit_is_set(PINA,1)){
								while(!bit_is_set(PINA,0));
								cont=4;
								break;
							}
					}
					
					if(cont==1){
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print("Nu are nici un");
						LCD_printAt(45,"efect...");
						_delay_ms(5000);
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print("bomba explodeaza");
						LCD_printAt(45,"BOOOOOOOM");
						_delay_ms(5000);
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print("GAME OVER");
						//LCD_printAt(45,"BOOOOOOOM");
						_delay_ms(5000);
					}
					if(cont==2){
						//LCD_writeInstr(LCD_INSTR_clearDisplay);
						//LCD_print("Nu are nici un");
						//LCD_printAt(45,"efect...");
						//_delay_ms(5000);
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print("bomba explodeaza");
						LCD_printAt(45,"BOOOOOOOM");
						_delay_ms(5000);
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print("GAME OVER");
						//LCD_printAt(45,"BOOOOOOOM");
						_delay_ms(5000);
					}
					if(cont==3){
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print("Sarpele are gura");
						LCD_printAt(45,"cascata.");
						_delay_ms(5000);
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print("Acum nu mai");
						LCD_printAt(45,"ramane decat sa");
						_delay_ms(5000);
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print("punem bomba in");
						LCD_printAt(45,"sarpe, nu?");
						_delay_ms(5000);
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print("Felicitari,");
						LCD_printAt(45,"ai supravietuit.");
						_delay_ms(5000);
						break;
					}
				}
				if(cont==3){
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Bomba a explodat");
					LCD_printAt(45,"BOOOOOOOOOM");
					_delay_ms(5000);
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("GAME OVER");
					//LCD_printAt(45,"prin usa");
					_delay_ms(5000);
					break;
				}
				if(cont==4){
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Ai fost muscat");
					LCD_printAt(45,"de sarpe");
					_delay_ms(5000);
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("GAME OVER");
					//LCD_printAt(45,"prin usa");
					_delay_ms(5000);
					break;
				}
				/*LCD_print("Esti Paul Atreides, cel mai nobil si onorabil din neamul Atreizilor. Esti o clona a originalului. In fata ta se afla o alta
				clona a originalului: Paolo. Razboiul dintre oameni si masini este in punctul culminant, iar omenirea are nevoie de un oracol, de o
				calauza: tu sau Paolo. Cum ajungi sa devii acea calauza, si sa ramai cu mintea intreaga in acelasi timp");
				*/
				
				/*Esti in avion. Vezi o bomba, un sarpe mare, usa de la avion, ferestrele si o lopata. Ai cateva secunde sa scapi de bomba. Alege:
				1) Deschide usa
				2) Ia lopata
				3) Loveste bomba
				4) Loveste sarpele
				
				1) Ai fost tras prin usa
				2) Ai lopata in mana. Alege:
				3) Bomba a explodat
				4) Ai fost muscat de sarpe
				
				1) Loveste usa cu lopata
				2) Loveste bomba cu lopata
				3) Casca-i gura sarpelui cu lopata
				4) Loveste geamurile cu lopata
				
				1) Nu are nici un efect... bomba explodeaza
				2) Bomba explodeaza
				3) Sarpele are gura cascata. Alege:
				4) Se sparg geamurile...esti tras prin ele
				
				Acum nu mai ramane decat sa punem bomba in sarpe, nu? Felicitari, ai supravietuit.
				*/
			}
			
		}
	
	
	
    return 0;


}